import numpy as np
import matplotlib.pyplot as plt
import sys

from scipy.integrate import odeint

if len(sys.argv[1]) > 0:
    ilkSıcaklık = sys.argv[1]
else:
    ilkSıcaklık = 25

adet = 300  # Saniye cinsinden nokta sayısı (300 adet)
t = np.linspace(0,adet,adet) # Zaman aralığı

# veri
sıcaklıkListesi = []

with open('sıcaklık00.txt') as kütük:
    satırlar = kütük.read().splitlines()

for satır in satırlar:
    sıcaklıkListesi.append(float(satır))

sıcaklıkListesi2 = []

with open('sıcaklık01.txt') as kütük:
    satırlar = kütük.read().splitlines()

for satır in satırlar:
    sıcaklıkListesi2.append(float(satır))

ortamSıcaklığı = 23

# hesap
k = 0.203312
y = -50 * k * np.exp(-t/150) + 50 * k + float(ortamSıcaklığı)

# bilgileri giriyoruz
# k'yı ayrıntılı hesaplıyoruz
k= (34 * np.exp(2) - np.exp(2) * float(ortamSıcaklığı)) / (50 * (np.exp(2) - 1))
çalıştırmaSüresi = 150.0 # saniye
dışSıcaklık = float(ortamSıcaklığı)
ilkSıcaklık = float(ilkSıcaklık)
dolulukOranı = 50.0

# türevli denklem
def türevliDenklem(ilkSıcaklık, t, k, dolulukOranı,
                   çalıştırmaSüresi, dışSıcaklık):
    sıcaklıkDeğişimi = ((dışSıcaklık - ilkSıcaklık) + k * dolulukOranı)  / çalıştırmaSüresi
    return sıcaklıkDeğişimi

sonuç = odeint(türevliDenklem,ilkSıcaklık,t,
               args=(k, dolulukOranı, çalıştırmaSüresi,dışSıcaklık))

# Sonuçları yazdır
plt.figure(1)
plt.plot(t,sonuç,'c-',label='Türevli denklem')
plt.plot(t,sıcaklıkListesi,'b.',label='Ölçülen1')
plt.plot(t,sıcaklıkListesi2,'r.',label='Ölçülen2')
plt.plot(t,y,'m',label='Hesap', linestyle = 'dashed')
plt.ylabel('Sıcaklık (°C)')
plt.xlabel('Zaman (saniye)')
plt.legend()
plt.show()
